Doc for version v1.3 of the snes assembler. (Snes-Pac)

Copyright 1992-1994 Elitendo
No permission to sell this program for ANY amount of money.
Permission to give it away for FREE or swap against other software.

Updated: 1.3
------------

New directives:	ifeq/ifne/endc

If the Expression is True then include code
If not true skip code until endc

Example:

levels_on	equ	1	;if 0 then both examples reverse

	ifeq	levels_on	;not true, skip code
	cmp	#1	;not included	
	endc		;end marker

	ifne	levels_on	;true, include
	cmp	#10	;included
	endc		;endmarker

Do NOT use nested ifeq/ifne's!!
;------------------------------------------
New directive:	include sources

Example:
	include	source.src
	include	"c:\snes\test.src"

There is 50.000 bytes memory reserved in the bss for include sources.
Errors will display the correct line in the include source, but
jump to error fails here.
;---------------------------------------------
New directive:	dce

Same as dcb but eor's the value with #$a5
Only works on byte values

Example:

	dcb	'test'	;normal
	dce	'test'	;this line is eor'd
	dce	0	;becomes $a5
;----------------------------------------------
Shift-Alt-S or the same in menu entry, will now save correctly
after inserting sources, it saves the Top-window name & path.


Updated: 1.2c
-------------
example of	(.d) opcode-directive

error   jsr     label   ;2nd pass wrong
        stz     test    ;converts to 3 bytes
test    equ     $02     ;label defined afterwoods is wrong
label   nop

How to fix:

ok      jsr     label   ;works ok
test    equ     $02
        stz     test    ;converts to 2 bytes
label   nop

or:

ok      jsr     label   ;works ok
        stz.d   test    ;force direct mode!!!<<<<<<<<
test    equ     $02
label   nop


For compatibility with snasm there's a few extra's:

(pseudo) opcodes:

        mode16          ;macro type of things
        mode8
        modea16
        modea8
        modei16
        modei8

these convert to rep/sep correct values + used internal use like below.

        longa   on      ;set or resets INTERNAL counters
        longa   off
        longi   on
        longi   off 

No more need to use '.l' for immideate instructions:

However if both is used, .l has the privilege.<<<<<<<<<

        li/la/si/sa  no longer work, removed... 

     

Updated: 1.2b
-------------
Memory management error fixed, no more 'out of memory' after loading
a few sources.
;--------------------
New directive:  dct

        dct     $208123         ;24 bit number: define char triple

        org     $148299
test    dct     test            ;converts to $148299
        wturn   on              ;set 
        dct     test            ;converts to $998214
        wturn   off
;---------------------
Org directive below $XX8000 didn't work, is fixed now. 
;-------------------
New: negative numbers for dcb/w/t & immediate instructions

        dcb     -1,-10,10,....
        dcw     -1,-$2000,...
        dct     -1,-$123456,...
        ldx     #-1
        lda.l   #-2000

Only checks for a negative sign at the beginning of an expression!
;------------------

Error in label check fixed, wrong label expression crashed with 2 bombs.

Bin could only load $8000 bytes a time, this is now up to
$180000 (12mbit) in size, the bad boundery cross will be displayed
if $8000 is exceeded but does not result in errors.
If org bit 15 is NOT set, this means below the $XX8000 boundery
like on org $c00000, boundery crosses will not be displayed, because
the programcounter needs no 'boundery updates'.  

No more vectors set at option assemble extend/no header.


How to use direct, absolute & absolute long sizes.
Direct (sta $xx) adds the direction register to the value.

        lda.l   #$4200          ;set accu to 4200
        tad                     ;put $4200 in direction register
        lda     $10             ;load contents of $4210 !!

All values below $100 automatically become direct instrucions, you can
force them into absolute mode by using .w
        
        lda     $0020           ;direct mode $20 !!
        lda.w   $0020           ;absolute mode

All values between $100-$ffffff become absolute instructions.
 
        sta     $4210           ;16 bit
        sta     $7e8000         ;converts to sta $8000 !
        
To use absolute long you'll need to add .l

        sta.l   $7e8000         ;force 24 bit mode. This one is ok.
        sta.l   $000020         ;force 24 bit
        jml     $7e8000         ;jml/jsl are always 24 bit.


Updated: 1.2a

--------------
new directives:

        wturn   on      ;turns around all dcw values (INTEL)
                        ;(use on dcw label if used as adres pointer)!!!!!

        wturn   off     ;default, don't turn around dcw's (NO INTEL)

(previous version had a default wturn on !!!)
-------------------------------------------------------------

How snes-pac works:
-------------------

PSEUDO OPCODES:
~~~~~~~~~~~~~~~
  
All pseudo/normal opcodes can be mixed upper/lowercase.
Labels CANNOT be mixed.
All pseudo opcodes need the 1st 3 characters to be recognized by the 
assembler. So 'nat' will be the same as 'native'.
Normal opcodes may NOT be extended (only with .l and a few others) 

org = original place where the code should begin.
      (sets internal programcounter to assigned value)
      If no org is set, $8000 will be assumed.
      All absolute references will be affected.

Example 1:

        ORG     $F000           ;assume code starts at $f000
start   jmp     start           ;jump to $f000

Use other values if you have to insert the code into a game at a
certain place or so.

Example 2:
        org     $700            ;this is ok
start   jmp     start           ;start begins at adres $700
         
-----------------------------------------------------------------------

nat = native mode 16 bits will put an clc & xce in code!!!!
emu = emulation mode 8 bits will put an sec & xce in code!!!

Example 1:
        
        sei
        native          ;ONLY THE 1ST 3 ARE CHECKED
        
Same as above:

        sei
        clc             ;clear carry flag
        xce             ;Xfer carry flag to emulation flag >16 bit mode
        
--------------------------------------------------------
There are pseudo opcodes used ONLY between int and end:
Use these things to get the vectors at the right place.

int = interrupt handling startlist (tells assembler list begins here)
all = set ALL interrupts to a certain value,(8 & 16 bit)
nmi = non maskable interrupt vector
res = reset vector
brk = break vector
abo = abort vector
cop = coprocessor vector 
irq = interrupt request vector
end = end of interrupt handling list(tells assembler this is the END of list)

Example 1:

        interrupts
all_vecs =       rti_instr       ;set ALL vectors to point at rti_instr
reset    =       startprogram    ;reset vector to startprogram
                                 ;all of this must point to 1st bank! 
         end                     ;don't forget end!!!!!
                                 ;use all first!!! else res will be the same!

startprogram    nop
                ......
rti_instr       rti
nmi_start       jml     vbl_native      ;see below
nmi_emu         jml     vbl_emulation 

If you want a specific emulation or native vector defined you can use:
the .e or .n attached to the 1st label. 

Example 2:

        int
all     equ     rti_instr
res     equ     startprogram    ;res=always emulation mode
irq.n   equ     irq_start       ;set irq native vector
irq.e   equ     irq_emu         ;same but for emulation
        end

All interrupt vectors MUST point to the 1st bank.
Snes works no other way!
--------------------------------------------------------------
bin = binary include of file (specify drive an path if needed)
      Files may not exceed $180000 bytes of length.
      
Example 1:

cynixlogo       bin     c:\snes\logo.bin

Example 2:

grafix_start    bin     "c:\logo.bin"

-----------------------------------------------
dcb = define character byte
dcw = word size
dct = triple size
dsb = define space/storage byte (fill up space with $00)
dsw = word size fillup

These can also be typed as dc.b or ds.w etc..

Example:
       
datafield dc.b    $31,20,%00000001,$ff-14,"test",10,'shit'
fillup    dsw     $200

          wturn   on
start     dcw     start,start+40,'ab',$1234
          wturn   off
         

If Wturn on is used,
all dcw/dct values will be converted to intel format!
until wturn off.
so $1234 will become $3412 and 'ab' will become 'ba' !!
labels can be used, but stay in the same bank! 
--------------------------------------------------------------------
pad = pad to next bank, set internal programcounter at the beginning
      of a next bank. (inbetween space is filled with 0)

Example 1:

start      jml     nextbank     ;start=$8000
           nop                  ;$8004
           rep     #$20
           ldx.l   #'ab'        ;swichtes to ..ba !!
label      padbank              ;label points at $8009 !!!!!
nextbank   nop                  ;nextbank=$18000
           nop                  ;$18001
           sep     #$20
           ldx     #'A'         ;load x register with $41

Example 2:
        
start      jml     nextbank
           nop
           pad     $ffc0        ;With VALUE things change a little
           dc.b    "Made by me..."
           pad
nextbank   nop

pad $ffc0 will skip the programcounter to adres $ffc0 (info area)
Values between $8000-$ffff will be accepted. Others will be masked off!
Errors in these values are NOT displayed.

If you don't put any text at the info area, the assembler will automaticly
fill it with our copyrights. (Snespac-Elitendo)

Example 3:

        pad     $18000          ;set counter to $8000!!!
                                ;use single pad instead

You cannot use any labels in the pad command!
The only check after pad is $.... if no dollar sign found it assumes
a single pad command.

If the programcounter crosses the bank boundary you will be informed
with: Boundery cross ok at line ...
So each pad does this. So you know what is happening. At what line
it has crossed.

If a boundery is crossed NOT using the pad command, it will be checked
on a 'bad cross', and inform you this has happend.
A bad cross is for instance: a jml $188000 starting at $01fffe.
The instruction is 4 bytes and sets the counter to $028002

Another one is: using bin and cross the boundery.

It will display the error, but will not be handled as an error.
Assembling will be continued, you might want to cross the boundery this way?
----------------------------------------------------------------------------
Label values can have byte, word, or long(3 bytes) length.

Long labels need .l attached to the opcode.(cannot use equ)
     (except for jsl or jml)
Word labels need no extension. They can be defined with equ,
     or at the beginning of a line.
Byte labels can only be defined in the equ table.

Example:

tab     equ     9       ;byte label
nmiflag equ     $4200   ;word label

        org     $8000
        
        sep     #$30    ;set a,x,y to 8 bit
start   ldx     #tab    ;load 9 in x register
        stx     nmiflag ;put 9 in adres $4200
        lda     start   ;load $8002 in accumulator
        ldy.w   #$1234  ;word length
        ldy.l   #$1234  ;word length 
        jml     bank2   ;long label
        pad
bank2   nop
-----------------------------------------------------------------
Error checking:
~~~~~~~~~~~~~~~
Each error adds 1 to the internal error counter if > 0 no program
will be saved or no send will be done. Also if an error occured in pass 1,
pass 2 will be canceled.


Illegal opcode at line 1 jms

Example:
test    jms     loop    ;jms does not exist

Illegal operand at line 1

Example:

test    jsr     [$12],x         ;adressing mode is wrong

Error in expression at line 1

Example:

test    ldy.l   #(test/2)*(test^4   ;last parenthesis missing

or      ldy     #4>1                ;shift right must be >>

Maximal 1000 labels of 22 characters length can be handled.
If using too much, you will be informed.
Better save a few banks (no header) then bin them in if you're short
on labels.

In the first Pass each label is checked whether its defined twice, you
will be informed on doubles. At the 2nd pass labels will be checked if they
are missing or if the size is incorrect, you will be informed as well.
Short labels(byte) are checked in the 1st pass and must be defined before
you call them.
               

Error example:
        
        org     $8000
start   nop             
        bra     bank2   ;This branch is too far>error
        pad             ;bra must be within byte boundery (signed!)
bank2   nop
        jmp     start   ;also wrong this is an absolute word length jump

        jml     start   ;this one is ok (not an original one)
                        ;actually it should be jmp,but it's hard to make
                        ;any error checks on jmp long/jmp absolute
or      jmp.l   start   ;also ok (these 2 are replacements)

        jsr     start   ;wrong
        jsr.l   start   ;ok (added to make it compatible)
        jsl     start   ;this is ok (this IS original)    

rep and sep don't affect the size of the operand while assembling!
If an opcode is followed by .l it will generate a long form.
also ok for immediate adressing is .w (not for absolute modes!)

so ldx   #1 = will assemble 2 bytes
   ldx.l #1 = '''           3 bytes 

if cpx #$1234 is found, an out of range error will occur
change it to cpx.w or cpx.l or cpx.v #$1234

.w = word size 2 bytes (only immedate forms)
.l = long size 2 or 3 bytes (immediate or absolute forms)
.v = same as .w ,to keep it compatible with the baseline assembler
.v stands for some kind of Finnish name.
every other extender will be ignored.

If you want to use absolute long labels(pointers to other banks) use
the .l extension!!!

Example:        ldx.l   #$120*2         ;multiply
                ldx     #$20/10         ;divide
loop            ldx     #20+90          ;add
                ldx.l   #$4490-20       ;minus
                lda     loop+4,x        ;all 4 work on labels too

;---------------------------------------------------------------
rept/endr = repeat/end repeat

format: assembles 10*nop

label   rept    10      ;values between 0-$ffff
        nop             ;NO labels in between!
        endr 

Set = set temporary value (used for rept)

format:

label   equ     1               ;init label with 1
       
label2  rept    10
        lda     #label          ;1,2,....10
        sta     $2000+label
        set     label+1         ;add 1 to label value each time
        endr                    ;subtract 1 from rept counter until 0

Nested rept is NOT included!
--------------------------------------------------
Recursive calculation:

Used operators:

+,-     add,minus
*       multiply
/       quotient of division
%       remainder of division
&       logical and
!       logical or
~       compliment (not)
^       eor
<<      shift left x times  (22<<4)
>>      shift right x time (22>>5)
()      parenthesis
[]      brackets

%       binary
$       hex
        decimal
        labels
--------------------------------------

Various (rare) instruction forms:

wdm     #$12            ;illegal opcode uses 2 bytes gives NO error assembling.
brk     #$12            ;calls break vector
cop     #$12            ;calls coprocessor vector
rep     #%00100000      ;set accumulator moves to 16 bit
rep     #%00010000      ;set all X and Y moves to 16 bit
sep     #%00100000      ;set accumulator moves to 8 bit
sep     #%00010000      ;set X and Y moves to 8 bit
pei     ($12)           ;push to stack
per     relative        ;push relative adres to stack
brl     relative        ;branch long, stay IN bank
bra     relative        ;short form
mvp     #$12,#$34       ;move blocks, using x,y as offsets, accu as counter
mvn     #$12,#$34       ;same but negative 12 34 are bank numbers? 
tcd = tad               ;both of these opcodes can be used
tcs = tas
tdc = tda
tsc = tsa 

----------------------------------------------------------------
Assemble options:
~~~~~~~~~~~~~~~~~
Extend, add header = fill up the bank 'till the end, fill in the VECTORS
                     at the 1st bank and glue a header to it.

Extend, no header  = only fill up to a whole bank, no vectors set.

No extend          = Binary file just the assembled bytes. No vectors!

Send to Snes       = If on, and assembled without errors, it sends.
------------------------------------------------------------------
JUMP TO ERROR
~~~~~~~~~~~~~
When about 11 or more errors occured in assembling, the editor jumps
automaticly to the 1st error, then you can jump to the next one by 
pressing alt-j. After the last one it will jump to the 1st one again.
--------------------------------------------------------------------- 

                The Magician. (MCA)

